;**********************************************************************
;Original version from Ulli, DF6JB for the EasyDsp. 
;Adapted to DSP56002EVM for Jabi, EA2ARU
;100% running ok with the JvComm32.
;28 November 1998.
;**********************************************************************
; equates
start   equ     $40
txdval  equ     $00F800
blival  equ     $00FFFF
bustart equ     $1000
buend   equ     $8000

; variables
        org     l:10
scirx   ds      5
scitx   ds      5
sciti   ds      5
irqad   ds      5
theta1  dc      @LNG(0,0)
theta3  dc      @LNG(0,0)
        org     y:*
t_out   dc      HEADPHONE_EN+LINEOUT_EN+(LEFT_ATTN*0)
t_inp   dc      MIC_IN_SELECT+(1*MONITOR_ATTN)+(RIGHT_ATTN*0)
txdelay dc      txdval
bldelay dc      blival
sin2400 dc      0
cos2400 dc      0
step1   dc      64,0.0
step3   dc      64,0.0
sinsend dc      0
inple   dc      0
inpri   dc      0
ichan   dc      0
qchan   dc      0
demsig  dc      0
flags   dc      0
test    dc      0
senbyte dc      0


        org     p:$0
        jmp     start

        org     p:$000c
        jsr     ssi_rx_isr              ;SSI receive data
        jsr     ssi_rx_isr              ;SSI receive data with exception
        jsr     ssi_tx_isr              ;SSI transmit data
        jsr     ssi_tx_isr              ;SSI transmit with exception


        org     p:$0014
irqrx   jsr     rx                      ;rx interrupt routine

        org     p:$0016
irqrxer jsr     rxerr                   ;rx interrupt routine with errors

        org     p:$0018
irqtx   jsr     tx                      ;tx interrupt routine

        org     p:$001C
irqti   jsr     timer                   ;sci timer interrupt routine

        org     p:start

        movep   #$26100A,x:PLL 
        movep   #$0000,x:BCR            ;slow memory in y:iospace
        ori     #3,mr                   ;mask interrupts
        movec   #0,sp                   ;clear hardware stack pointer
        move    #4,omr                  ;operating mode 4 (sintable enabled)
        move    #$40,r6                 ;initialise stack pointer
        move    #-1,m6                  ;linear addressing
        move    #bustart,r1             ;initialise rx ring buffer pointer
        move    #bustart,r2             ;initilaize tx ring buffer pointer
        move    #$FFFF,m1               ;rx ring buffer linear adressing
        move    #$FFFF,m2               ;tx ring buffer linear adressing
        move    #0,n1                   ;no offset
        move    #0,n2                   ;no offset

        include 'ada_init.asm'
	include 'macros.asm'

        ;initialize port B
	movep   #$0000,x:PBC	        ;port B as general purpose port
	movep	#$60ff,x:PBDDR	        ;PB0-PB7,PB13 and PB14 as outputs
	movep   #$0000,x:PBD

        ;initialize SCI
	movep   #$01EB,x:PCC            ;turn sci on
        movep   #$B006,x:IPR            ;sci interrupt priority 2,irqa 1
	movep	#$2B02,x:SCR	        ;8,n,1, rx/tx enable,rx int enable, timer int enable
	movep   #5,x:SCCR               ;115200 baud

;**********************************************************************
main    jset    #2,x:SSISR,*            ;wait for frame sync to pass
        jclr    #2,x:SSISR,*            ;wait for frame sync

        move    x:RX_BUFF_BASE,a        ;receive left
	asl	a
	asl	a
	asl	a

        move    x:RX_BUFF_BASE+1,b      ;receive right
	asl	b
	asl	b
	asl	b

        move    a,y:inple
        move    b,y:inpri

        move    y:sinsend,x0
        move    y:senbyte,y0
        mpy     x0,y0,a
        move    #0,b

        move    a,x:TX_BUFF_BASE        ;transmit left
        move    b,x:TX_BUFF_BASE+1      ;transmit right
        move    y:t_out,y0              ;set up output control word
        move    y0,x:TX_BUFF_BASE+2     ;and send it
        move    y:t_inp,y0              ;set up input control word
        move    y0,x:TX_BUFF_BASE+3     ;and send it

sins    presin  step3,theta3,sinsend    ;generate the send signal
        ptt     tst                     ;test if ptt is on
        jcc     receiv                  ;if not jump to receive
        jsr     proctx                  ;else process transmit buffer
        jmp     main
;**********************************************************************
receiv  clr     a
        move    a,y:sinsend             ;otherwise zero output signal
sin24   presin  step1,theta1,sin2400    ;generate 2400 Hz sine
cos24   precos  step1,theta1,cos2400    ;generate 2400 Hz cosine
        move    y:inple,a
norm    move    y:inple,x0
        fir     taps2,states4,coef2     ;remove everything below 200 Hz
        move    a,y:inple
        move    y:inple,x0
        move    y:sin2400,y0
        mpy     x0,y0,a                 ;mix input downto 0 with sine
        move    a,x0
filt1   fir     taps1,states1,coef1     ;and remove the sum frequencies
        move    a,y:ichan
        move    y:inple,x0
        move    y:cos2400,y0            ;mix input downto 0 with cosine
        mpy     x0,y0,a
        move    a,x0
filt2   fir     taps1,states2,coef1     ;and remove the sum frequencies
        move    a,y:qchan               ;now we have a analytic signal in
        move    y:ichan,b               ;ichan and qchan
        sqr     a                       ;square qchannel
        sqr     b                       ;sqare  ichannel
        add     b,a                     ;add result
        sqrt                            ;take the sqareroot of result
        move   a,x0
        fir    taps1,states3,coef1
        move   a,y:demsig
        tst    a
        jge    gr0
        clr    a
gr0     move   #>$1FE000,x0
        cmp    x0,a
        jle    kl0
        move   #>$1FE000,a
        cmdled set
        jmp    <amp
kl0     cmdled clr
amp     asr    a
        asr    a
        asr    a
        asr    a
        asr    a
        move   a,y:demsig
        bchg   #0,y:flags
        jcc    main
        btst   #2,y:flags
        jcs    main
        move   a,x:$FFF5	;Enva la seal demodulada

;**********************************************************************
;ARU: si el valor del dato esta cerca de cero (negro), pone en ON CAT
;Si esta cerca de 255 (blanco), pone en ON led UP.
;Si escucha tono de 2400 Hz, pone en ON el led DCD.

          bclr  #3,X:$FFE4		; Apaga los leds
          bclr  #1,X:$FFE4
          bclr  #2,X:$FFE4
	  move #>$4000,x0		; Valor prximo a cero. 
	  cmp x0,a
	  .if <le>
;            bset #3,X:$FFE4		;Led de CAT ON.
	  .else
	    move #>$D000,x0		; Valor prximo a 255.
	    cmp x0,a
	    .if <ge>
;              bset #1,X:$FFE4		; Led de Up ON.
	    .else
              bset #2,X:$FFE4		; Led de DCD ON.
	    .endi
	  .endi
;**********************************************************************
        jmp    main

;**********************************************************************
proctx  bchg    #1,y:flags
        jcs     procend
        move    y:(r2)+,y0
        move    r2,a
        move    #buend,b
        sub     b,a
        jne     pcomp
        move    #bustart,r2
pcomp   move    y0,a
        asl     a
        asl     a
        asl     a
        asl     a
        asl     a
        asl     a
        asl     a
        move    a,y:senbyte
        move    r2,a
        move    r1,b
        sub     b,a
        jne     procwei
        ptt     clr
        cmdled  clr
        jmp     procend
procwei jpl     pueber
        move    #>$2000,b
        add     b,a
pueber  move    #>5000,b
        sub     b,a
        jmi     procend
        jsr     setcts
        cmdled  set
procend rts

clrcts  bset	#1,X:$FFE4
        rts

setcts  bclr	#1,X:$FFE4
        rts

rx      enter   scirx                   ;sci rx interrupt routine
        ptt     set
        bset    #2,y:flags
        move    #blival,a0
        dialed  clr
        move    a0,y:bldelay
        move    x:SSR,a
        move    x:$FFF5,x0
        move    x0,y:(r1)+
        move    r1,a
        move    #buend,b
        sub     b,a
        jne     rxcomp
        move    #bustart,r1
rxcomp  move    r2,a
        move    r1,b
        sub     b,a
        jpl     noueber
        move    #>$5000,b
        add     b,a
noueber move    #>1000,b
        sub     b,a
        jpl     rxend
        jsr     clrcts
        cmdled  clr
rxend   leave   scirx

rxerr   enter   scirx                   ;sci rx interrupt routine with errors
        move    x:$FFF6,a
        move    x:SSR,a
        leave   scirx

tx      enter   scirx                   ;sci tx interrupt routine
txend   leave   scirx

timer   enter   sciti                   ;sci timer interrupt routine
        ptt     tst
        jcs     endti
        clr     a
        move    y:bldelay,a0
        dec     a
        move    a0,y:bldelay
        tst     a
        jne     endti
        move    #blival,a0
        move    a0,y:bldelay
        dialed  chg
        bclr    #2,y:flags
endti   leave   sciti
;**********************************************************************
        include 'txrx_isr.asm'

taps1   equ     27
taps2   equ     27

        org     x:$500
states1 dsm     taps1
states2 dsm     taps1
states3 dsm     taps1
states4 dsm     taps2

        org     y:$500
coef1
; FIR lowpass filter
; Generated by FIRfilt(c)
;
; DSP56000 family format
;
; Edges (Hz):
;  0...1214.814815
;  2392.592593...4800
;
; Specified deviations (dB):
;  0.1000000015
;  -91.07142857
;
; Worst deviations (dB):
;  0.1425436635
;  -87.81389904
;
; Target precision: fixed point 24 bit, unnormalized
;
; 27 coefficients:

  dc  -7.19189644E-004    ; h[0]
  dc  -3.40962410E-003    ; h[1]
  dc  -7.50672817E-003    ; h[2]
  dc  -8.20577145E-003    ; h[3]
  dc   5.92947006E-004    ; h[4]
  dc   1.64308548E-002    ; h[5]
  dc   2.27031708E-002    ; h[6]
  dc   1.32131577E-003    ; h[7]
  dc  -4.04754877E-002    ; h[8]
  dc  -5.89431524E-002    ; h[9]
  dc  -3.45468521E-003    ; h[10]
  dc   1.29810095E-001    ; h[11]
  dc   2.74732590E-001    ; h[12]
  dc   3.37708831E-001    ; h[13]
  dc   2.74732590E-001    ; h[14]
  dc   1.29810095E-001    ; h[15]
  dc  -3.45468521E-003    ; h[16]
  dc  -5.89431524E-002    ; h[17]
  dc  -4.04754877E-002    ; h[18]
  dc   1.32131577E-003    ; h[19]
  dc   2.27031708E-002    ; h[20]
  dc   1.64308548E-002    ; h[21]
  dc   5.92947006E-004    ; h[22]
  dc  -8.20577145E-003    ; h[23]
  dc  -7.50672817E-003    ; h[24]
  dc  -3.40962410E-003    ; h[25]
  dc  -7.19189644E-004    ; h[26]

        org     y:$600
coef2
; FIR highpass filter
; Generated by FIRfilt(c)
;
; DSP56000 family format
;
; Edges (Hz):
;  0...407.4074074
;  1148.148148...4800
;
; Specified deviations (dB):
;  -49.64285714
;  0.1000000015
;
; Worst deviations (dB):
;  -45.22451963
;  0.1660135998
;
; Target precision: fixed point 24 bit, unnormalized
;
; 27 coefficients:

  dc  -1.11905336E-002    ; h[0]
  dc  -1.45637989E-003    ; h[1]
  dc   3.67653370E-003    ; h[2]
  dc   1.15120411E-002    ; h[3]
  dc   1.93917751E-002    ; h[4]
  dc   2.34061480E-002    ; h[5]
  dc   1.93511248E-002    ; h[6]
  dc   4.11951542E-003    ; h[7]
  dc  -2.29549408E-002    ; h[8]
  dc  -5.93794584E-002    ; h[9]
  dc  -9.96342897E-002    ; h[10]
  dc  -1.36351109E-001    ; h[11]
  dc  -1.62082195E-001    ; h[12]
  dc   8.28660488E-001    ; h[13]
  dc  -1.62082195E-001    ; h[14]
  dc  -1.36351109E-001    ; h[15]
  dc  -9.96342897E-002    ; h[16]
  dc  -5.93794584E-002    ; h[17]
  dc  -2.29549408E-002    ; h[18]
  dc   4.11951542E-003    ; h[19]
  dc   1.93511248E-002    ; h[20]
  dc   2.34061480E-002    ; h[21]
  dc   1.93917751E-002    ; h[22]
  dc   1.15120411E-002    ; h[23]
  dc   3.67653370E-003    ; h[24]
  dc  -1.45637989E-003    ; h[25]
  dc  -1.11905336E-002    ; h[26]


        end

