;**********************************************************************
;Original version from Ulli, DF6JB for the EasyDsp. 
;Adapted to DSP56002EVM for Jabi, EA2ARU
;100% running ok with the JvComm32.
;28 November 1998
;**********************************************************************; equates
start   equ     $40
txdval  equ     $00F800
blival  equ     $00FFFF
bustart equ     $1000
buend   equ     $8000

; variables
        org     l:10
scirx   ds      5
scitx   ds      5
sciti   ds      5
irqad   ds      5
theta1  dc      @LNG(0,0)
theta3  dc      @LNG(0,0)
        org     y:*
t_out   dc      HEADPHONE_EN+LINEOUT_EN+(LEFT_ATTN*0)
t_inp   dc      MIC_IN_SELECT+(1*MONITOR_ATTN)+(RIGHT_ATTN*0)
txdelay dc      txdval
bldelay dc      blival
sin1700 dc      0
cos1700 dc      0
step1   dc      45,0
step3   dc      0,0
sinsend dc      0
inple   dc      0
inpri   dc      0
ichan   dc      0
qchan   dc      0
deli    dc      0
delq    dc      0
txbyte  dc      0
demsig  dc      0
odemsig dc      0
flags   dc      0
test    dc      0


        org     p:$0
        jmp     start

        org     p:$000c
        jsr     ssi_rx_isr              ;SSI receive data
        jsr     ssi_rx_isr              ;SSI receive data with exception
        jsr     ssi_tx_isr              ;SSI transmit data
        jsr     ssi_tx_isr              ;SSI transmit with exception


        org     p:$0014
irqrx   jsr     rx                      ;rx interrupt routine

        org     p:$0016
irqrxer jsr     rxerr                   ;rx interrupt routine with errors

        org     p:$0018
irqtx   jsr     tx                      ;tx interrupt routine

        org     p:$001C
irqti   jsr     timer                   ;sci timer interrupt routine

        org     p:start

        movep   #$26100A,x:PLL       
        movep   #$0000,x:BCR            ;slow memory in y:iospace
        ori     #3,mr                   ;mask interrupts
        movec   #0,sp                   ;clear hardware stack pointer
        move    #4,omr                  ;operating mode 4 (sintable enabled)
        move    #$40,r6                 ;initialise stack pointer
        move    #-1,m6                  ;linear addressing
        move    #bustart,r1             ;initialise rx ring buffer pointer
        move    #bustart,r2             ;initilaize tx ring buffer pointer
        move    #$FFFF,m1               ;rx ring buffer linear adressing
        move    #$FFFF,m2               ;tx ring buffer linear adressing
        move    #0,n1                   ;no offset
        move    #0,n2                   ;no offset

        include 'ada_init.asm'
	include 'macros.asm'	

        ;initialize port B
	movep   #$0000,x:PBC	        ;port B as general purpose port
	movep	#$60ff,x:PBDDR	        ;PB0-PB7,PB13 and PB14 as outputs
	movep   #$0000,x:PBD

        ;initialize SCI
	movep   #$01EB,x:PCC            ;turn sci on
        movep   #$B006,x:IPR            ;sci interrupt priority 2,irqa 1
	movep	#$2B02,x:SCR	        ;8,n,1, rx/tx enable,rx int enable, timer int enable
	movep   #5,x:SCCR               ;115200 baud

;**********************************************************************
main    jset    #2,x:SSISR,*            ;wait for frame sync to pass
        jclr    #2,x:SSISR,*            ;wait for frame sync

        move    x:RX_BUFF_BASE,a        ;receive left
        move    x:RX_BUFF_BASE+1,b      ;receive right

        move    a,y:inple
        move    b,y:inpri

        move    y:sinsend,a
        move    #0,b

        move    a,x:TX_BUFF_BASE        ;transmit left
        move    b,x:TX_BUFF_BASE+1      ;transmit right
        move    y:t_out,y0              ;set up output control word
        move    y0,x:TX_BUFF_BASE+2     ;and send it
        move    y:t_inp,y0              ;set up input control word
        move    y0,x:TX_BUFF_BASE+3     ;and send it

sins    presin  step3,theta3,sinsend    ;generate the send signal
        ptt     tst                     ;test if ptt is on
        jcc     receiv                  ;if not jump to receive
        jsr     proctx                  ;else process transmit buffer
        ptt     tst                     ;test again ptt
        jcs     main                    ;if ptt we are ready
        jmp      main

receiv  clr     a
        move    a,y:sinsend             ;otherwise zero output signal
sin17   presin  step1,theta1,sin1700    ;generate 1700 Hz sine
cos17   precos  step1,theta1,cos1700    ;generate 1700 Hz cosine
        move    y:inple,a
        move    #0.9,x0
        cmpm    x0,a
        jle     norm
        move    #txdval,a
        move    a,y:txdelay
ovrdr   cmdled  set
norm    move    y:inple,x0
        move    y:sin1700,y0
        mpy     x0,y0,a                 ;mix input downto 0 with sine
        move    a,x0
filt1   fir     taps1,states1,coef1     ;and remove the sum frequencies
        move    a,y:ichan
        move    y:inple,x0
        move    y:cos1700,y0            ;mix input downto 0 with cosine
        mpy     x0,y0,a
        move    a,x0
filt2   fir     taps1,states2,coef1     ;and remove the sum frequencies
        move    a,y:qchan               ;now we have a analytic signal in
        move    y:ichan,b               ;ichan and qchan
        sqr     a                       ;square qchannel
        sqr     b                       ;sqare  ichannel
        add     b,a                     ;add result
        sqrt                            ;take the sqareroot of result
inv     invert                          ;compute a conversion faktor
        move    a,x0                    ;use conversion faktor for ichan
        move    y:ichan,y0
        mpy     x0,y0,a
        rep     #15
        asl     a
        move    a,y:ichan
        move    y:qchan,y0
        mpy     x0,y0,a
        rep     #15
        asl     a
        move    a,y:qchan               ;use conversion faktor for ichan
                                        ;now ichan and qchan are no more
                                        ;dependant from the input voltage

        move   a,x0
        move   y:deli,y0
        clr    a
        macr   x0,y0,a
        move   y:ichan,x0
        move   y:delq,y0
        clr    b
        macr   x0,y0,b
        neg    b
        add    b,a
        move   a,x0
filt3   fir    taps1,states3,coef1
        move   a,y:demsig
        move   a,y:test
        movi   y:ichan,y:deli
        movi   y:qchan,y:delq
        move   y:demsig,x0
        move   #0.2300737066,y0
        move   #0.0960987226,b
        mpy    x0,y0,a
        add    b,a
        asl    a
        move   a,y:demsig

mittel2 move   a,y0
        move   #0.5,x0
        mpy    x0,y0,a
        move   y:odemsig,y0
        move   #0.5,x0
        mpy    x0,y0,b
        add    b,a
        move   y:demsig,b
        move   b,y:odemsig
        move   a,y:demsig
        tst    a
        jge    gr0
        clr    a
gr0     move   #>$3FC000,x0
        cmp    x0,a
        jle    kl0
        move   #>$3FC000,a
kl0     rep    #6
        lsr    a
        move   a,y:demsig
        bchg   #0,y:flags
        jcc    main
        btst   #2,y:flags
        jcs    main
        move   a,x:$FFF5
        jmp    main

;**********************************************************************
proctx  bchg    #1,y:flags
        jcs     procend
        move    y:(r2)+,y0
        move    r2,a
        move    #buend,b
        sub     b,a
        jne     pcomp
        move    #bustart,r2
pcomp   move    #0.167320261438,x0
        mpy     x0,y0,a
        move    #0.333333333333,b0
        asl     b
        move    #>$1C,b1
        add     b,a
        move    a1,y:step3
        asr     a
        move    a0,y:step3+1
        move    r2,a
        move    r1,b
        sub     b,a
        jne     procwei
        ptt     clr
        cmdled  clr
        jmp     procend
procwei jpl     pueber
        move    #>$2000,b
        add     b,a
pueber  move    #>5000,b
        sub     b,a
        jmi     procend
        jsr     setcts
        cmdled  set
procend rts

clrcts  
        rts

setcts  
	rts

rx      enter   scirx                   ;sci rx interrupt routine
        ptt     set
        bset    #2,y:flags
        move    #blival,a0
        dialed  clr
        move    a0,y:bldelay
        move    x:SSR,a
        move    x:$FFF4,x0
        move    x0,y:(r1)+
        move    r1,a
        move    #buend,b
        sub     b,a
        jne     rxcomp
        move    #bustart,r1
rxcomp  move    r2,a
        move    r1,b
        sub     b,a
        jpl     noueber
        move    #>$5000,b
        add     b,a
noueber move    #>1000,b
        sub     b,a
        jpl     rxend
        jsr     clrcts
        cmdled  clr
rxend   leave   scirx

rxerr   enter   scirx                   ;sci rx interrupt routine with errors
        move    x:$FFF6,a
        move    x:SSR,a
        leave   scirx

tx      enter   scirx                   ;sci tx interrupt routine
txend   leave   scirx

timer   enter   sciti                   ;sci timer interrupt routine
        ptt     tst
        jcs     endti
        clr     a
        move    y:bldelay,a0
        dec     a
        move    a0,y:bldelay
        tst     a
        jne     endti
        move    #blival,a0
        move    a0,y:bldelay
        dialed  chg
        cmdled  clr
        bclr    #2,y:flags
endti   leave   sciti
;**********************************************************************
        include 'txrx_isr.asm'

taps1   equ     15

        org     x:$500
states1 dsm     taps1
states2 dsm     taps1
states3 dsm     taps1

        org     y:$500
coef1
     dc     -1.54390335E-002
     dc     -1.99656487E-002
     dc     -1.17244720E-002
     dc      2.25936174E-002
     dc      8.33967924E-002
     dc      1.56177163E-001
     dc      2.15950727E-001
     dc      2.39100218E-001
     dc      2.15950727E-001
     dc      1.56177163E-001
     dc      8.33967924E-002
     dc      2.25936174E-002
     dc     -1.17244720E-002
     dc     -1.99656487E-002
     dc     -1.54390335E-002

        end

