;**********************************************************************
; SSTV95 for JVComm32 and EasyDSP By Ulrich, DF6JB
; Small change for DSP56002EVM by Jabi, EA2ARU
; 18 November 1998
; Work 100% in RX and TX (1).
; Aucun led for detect sinc. 
; (1)Whit the actual version of JvComm32 (0.96cbeta), is precise one ;conection cable from pin8 (CTS in Host port) to PB15 for TX!!!!
;**********************************************************************
; equates
start   equ     $40
txdval  equ     $00F800
blival  equ     $008888
bustart equ     $1000		;$1000
buend   equ     $4000		;$8000

; variables
	org     l:10
scirx   ds      5
scitx   ds      5
sciti   ds      5
irqad   ds      5
theta1  dc      @LNG(0,0)
theta3  dc      @LNG(0,0)
	org     y:*
t_out   dc      HEADPHONE_EN+LINEOUT_EN+(LEFT_ATTN*6)
t_inp   dc      MIC_IN_SELECT+(1*MONITOR_ATTN)+(RIGHT_ATTN*0)
		;              |change to 15 to no monitor in RX.
txdelay dc      txdval
bldelay dc      blival
sin1700 dc      0
cos1700 dc      0
step1   dc      45,0
step3   dc      0,0
sinsend dc      0
inple   dc      0
inpri   dc      0
ichan   dc      0
qchan   dc      0
deli    dc      0
delq    dc      0
txbyte  dc      0
demsig  dc      0
odemsig dc      0
flags   dc      0

;**********************************************************************
;**********************************************************************

	org     p:$0
	jmp     start

	org     p:$000c
	jsr     ssi_rx_isr              ;SSI receive data
	jsr     ssi_rx_isr              ;SSI receive data with exception
	jsr     ssi_tx_isr              ;SSI transmit data
	jsr     ssi_tx_isr              ;SSI transmit with exception


	org     p:$0014
irqrx   jsr     rx                      ;rx interrupt routine

	org     p:$0016
irqrxer jsr     rxerr                   ;rx interrupt routine with errors

	org     p:$0018
irqtx   jsr     tx                      ;tx interrupt routine

	org     p:$001C
irqti   jsr     timer                   ;sci timer interrupt routine

	org     p:start

	movep   #$26100A,x:PLL          ;        
	movep   #$0000,x:BCR            ;EraF. Slow memory in y:iospace
	ori     #3,mr                   ;mask interrupts
	movec   #0,sp                   ;clear hardware stack pointer
	move    #4,omr                  ;operating mode 4 (sintable enabled)
	move    #$40,r6                 ;initialise stack pointer
	move    #-1,m6                  ;linear addressing
	move    #bustart,r1             ;initialise rx ring buffer pointer
	move    #bustart,r2             ;initilaize tx ring buffer pointer
	move    #$FFFF,m1               ;rx ring buffer linear adressing
	move    #$FFFF,m2               ;tx ring buffer linear adressing
	move    #0,n1                   ;no offset
	move    #0,n2                   ;no offset

	include 'ada_init.asm'
	include	'macros.asm'

	;initialize port B
	movep   #$0000,x:PBC            ;port B as general purpose port
	movep   #$60ff,x:PBDDR          ;PB0-PB7,PB13 and PB14 as outputs
	movep   #$0000,x:PBD

	;initialize SCI
	movep   #$01EB,x:PCC            ;turn sci on
	movep   #$B006,x:IPR            ;sci interrupt priority 2,irqa 1
	movep   #$2B02,x:SCR            ;8,n,1, rx/tx enable,rx int enable, timer int enable
        movep   #5,x:SCCR               ;115200 baud
;***********************************************************************

main    jset    #2,x:SSISR,*            ;wait for frame sync to pass
	jclr    #2,x:SSISR,*            ;wait for frame sync

	move    x:RX_BUFF_BASE,a        ;receive left
	move    x:RX_BUFF_BASE+1,b      ;receive right

	move    a,y:inple               ;inple= input_left
	move    b,y:inpri               ;inpri= input_right

	move    y:sinsend,a             ;seal de audio demodulada y a transmitir
	move    #0,b
	move    a,x:TX_BUFF_BASE        ;transmit left
	move    b,x:TX_BUFF_BASE+1      ;transmit right
	move    y:t_out,y0              ;set up output control word
	move    y0,x:TX_BUFF_BASE+2     ;and send it
	move    y:t_inp,y0              ;set up input control word
	move    y0,x:TX_BUFF_BASE+3     ;and send it

sins    presin  step3,theta3,sinsend    ;genera la seal de salida
;**********************************************************************
;PASA A RX o TX 
;**********************************************************************
	ptt     tst                     ;testea si ptt esta on va a TX
	jcc     receive                 ;si no salta a recepcion
	jsr     proctx                  ;si ptt on, procesa transmit buffer
	ptt     tst                     ;test again ptt
	jcs     main                    ;if ptt we are ready
;*******************************************************************************
; RUTINA de RECEPCION
;*******************************************************************************
receive clr     a
	move    a,y:sinsend             ;otherwise zero output signal
sin17   presin  step1,theta1,sin1700    ;generate 1700 Hz sine
cos17   precos  step1,theta1,cos1700    ;generate 1700 Hz cosine
;*******************************************************************************
; Nivel de entrada. No AGC.

	move    y:inple,a               ;rutina de oversampling. NIVEL de entrada!!!!
	move    #0.9,x0
	cmpm    x0,a
	jle     norm
	move    #txdval,a
	move    a,y:txdelay
ovrdr   cmdled  set
;*******************************************************************************
; Normalizacin

norm    move    y:inple,x0
	move    y:sin1700,y0
	mpy     x0,y0,a                 ;mix input down to 0 with sine
	move    a,x0
filt1   fir     taps1,states1,coef1     ;and remove the sum frequencies
	move    a,y:ichan

	move    y:inple,x0
	move    y:cos1700,y0            ;mix input down to 0 with cosine
	mpy     x0,y0,a
	move    a,x0
filt2   fir     taps1,states2,coef1     ;and remove the sum frequencies
	
	move    a,y:qchan               ;now we have a analytic signal in
	move    y:ichan,b               ;ichan and qchan

	sqr     a                       ;square qchannel
	sqr     b                       ;sqare  ichannel
	add     b,a                     ;add result
	sqrt                            ;Hace la raiz cuadrada

inv     invert                          ;compute a conversion faktor
	move    a,x0                    ;use conversion faktor for ichan

	move    y:ichan,y0
	mpy     x0,y0,a
	rep     #15
	asl     a
	move    a,y:ichan

	move    y:qchan,y0
	mpy     x0,y0,a
	rep     #15
	asl     a
	move    a,y:qchan               ;use conversion faktor for qchan


					;now ichan and qchan are no more
					;dependant from the input voltage
;**********************************************************************
; Fin de normalizacion
;**********************************************************************

	move   a,x0
	move   y:deli,y0
	clr    a
	macr   x0,y0,a
	move   y:ichan,x0
	move   y:delq,y0
	clr    b
	macr   x0,y0,b
	neg    b
	add    b,a
	move   a,x0
filt3   fir    taps1,states3,coef1
	move   a,y:demsig               ;Seal demodulada
	movi   y:ichan,y:deli
	movi   y:qchan,y:delq
	move   y:demsig,x0              ;tengo la seal demod. en x0
	move   #0.5099420057,y0
	move   #0.2489954247,b
	mpy    x0,y0,a                  ;multiplico por cte y la dejo en a.
	add    b,a                      ; la sumo con otra cte.
	move   a,y:demsig               ;seal demodulada

mittel2 move   a,y0             ; divide por 2 la seal demodulada.
	move   #0.5,x0
	mpy    x0,y0,a          ; lo deja en a.

	move   y:odemsig,y0     ; divide por 2 la antigua seal demodulada
	move   #0.5,x0
	mpy    x0,y0,b

	add    b,a              ; sumo las dos             
	
	move   y:demsig,b
	move   b,y:odemsig
	move   a,y:demsig       ; Esta debe ser la demodulada ok!!!!!!

	tst    a
	jge    gr0
	clr    a
gr0     move   #>$3FC000,x0
	cmp    x0,a
	jle    kl0
	move   #>$3FC000,a

kl0     rep    #6
	lsr    a

	move   a,y:demsig
	bchg   #0,y:flags
	jcc    main
	
	btst   #2,y:flags
	jcs    main
;**********************************************************************
; ARU: si el valor del dato esta cerca de 1200 Hz (sinc), pone en ON el ;led DCD.

        move #>$4000,x0		;$4400
	cmp x0,a
	.if <gt>
	bclr #2,X:$FFE4
	jmp ok 
	.endi
	bset #2,x:$FFE4		;Led de sinc ON
;**********************************************************************	
ok	move   a,x:$FFF5        ;Enva la seal por la direccin $FFF5:
				;puerta serie....
	jmp    main             ;Acaba RX y va al comienzo del loop.

;*******************************************************************************
;    Rutina de transmision
;*******************************************************************************
proctx  bchg    #1,y:flags
	jcs     procend

	move    y:(r2)+,y0
	move    r2,a
	move    #buend,b
	sub     b,a
	jne     pcomp
	move    #bustart,r2

pcomp   move    #0.146405228758,x0
	mpy     x0,y0,a
	move    #0.666666666667,b0
	asl     b
	move    #>$1A,b1
	add     b,a
	move    a1,y:step3
	asr     a
	move    a0,y:step3+1
	move    r2,a		;valor del bustart ($1000)
	move    r1,b		;valor recibido de la puerta serie
	sub     b,a
	jne     procwei		;NE es Z=0. Si a  b son 0 ir a procwei.	
	jsr	clrcts		
	ptt     clr             ;
	cmdled clr
	jmp     procend

procwei jpl     pueber
	move    #>4900,b       ;era $2000.Con 4900 ok      
	add     b,a
pueber  move    #>5000,b	;5000 
	sub     b,a
	jmi     procend
	jsr     setcts          ;CTS OFF:no recibe datos hasta que CTS ON.
procend rts
;*****************************************************************************
clrcts  bset #1,X:$FFE4         ;ARU pata CTS OFF
	rts
;****************************************************************************
setcts  bclr #1,x:$FFE4         ;ARU pata CTS ON
	rts
;*******************************************************************************
rx      enter   scirx
	ptt     set                     ;PTT ON
	bset    #2,y:flags
	move    #blival,a0
	dialed  clr
	move    a0,y:bldelay
	move    x:SSR,a
	move    x:$FFF4,x0              ;recibe datos el puerto serie
	move    x0,y:(r1)+
	move    r1,a			;tengo en el a el byte.
	move    #buend,b		;buend=$4000 en b.
	sub     b,a			;le resto el byte que llega y
					;el resultado en a.
	jne     rxcomp			;NE(Z=0): si A  B son iguales
					;a 0, va rxcomp
	move    #bustart,r1		;bustart=$1000		
rxcomp  move    r2,a			;que hay en r2????
	move    r1,b
	sub     b,a
	jpl     noueber			;jump si PL (PLUS, N=0, el bit 55 de 
					;a  b es 1)
	move    #>$5000,b
	add     b,a
noueber move    #>1000,b      
	sub     b,a
	jpl     rxend		;jump si N=0 (bit 55 de a  b son 1)
	jsr     clrcts          ;CTS ON:recibe datos.
	cmdled  clr

rxend   leave   scirx

;**********************************************************************

rxerr   enter   scirx                   ;sci rx interrupt routine with errors
	move    x:$FFF6,a
	move    x:SSR,a
	leave   scirx

tx      enter   scirx                   ;sci tx interrupt routine
txend   leave   scirx

timer   enter   sciti                   ;sci timer interrupt routine
;	ptt	tst			;1
;	jcs	endti			;1
	clr     a
	move    y:bldelay,a0
	dec     a
	move    a0,y:bldelay
	tst     a
	jne     endti
	move    #blival,a0
	move    a0,y:bldelay
	dialed  chg
	cmdled clr
	jsr     clrcts          	;ARU CTS ON
	bclr    #2,y:flags
endti   leave   sciti
;*****************************************************************************
;******************************************************************************
	include 'txrx_isr.asm'

taps1   equ     15

	org     x:$500
states1 dsm     taps1
states2 dsm     taps1
states3 dsm     taps1

	org     y:$500
coef1
     dc     -1.54390335E-002
     dc     -1.99656487E-002
     dc     -1.17244720E-002
     dc      2.25936174E-002
     dc      8.33967924E-002
     dc      1.56177163E-001
     dc      2.15950727E-001
     dc      2.39100218E-001
     dc      2.15950727E-001
     dc      1.56177163E-001
     dc      8.33967924E-002
     dc      2.25936174E-002
     dc     -1.17244720E-002
     dc     -1.99656487E-002
     dc     -1.54390335E-002

	end

